#
# spec file for package zoneminder (Version 1.24.4) openSuSE 11.x
#
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments to monex@liquid-co.de
#

# norootforbuild

%bcond_with mp_package
%bcond_without debug 

%if %{with mp_package}
Name:           ZoneMinder-MP
%else
Name:           ZoneMinder
%endif
BuildRequires:  apache2 php5 apache2-mod_php5 php5-mysql php5-bz2 php5-gd php5-zlib php5-iconv php5-mcrypt php5-sockets pcre-devel libjpeg-devel gcc gcc-c++ perl perl-Archive-Tar perl-Archive-Zip perl-DBI perl-DBD-mysql perl-Crypt-SSLeay perl-XML-Parser perl-libwww-perl perl-Date-Manip perl-MIME-Lite perl-MIME-tools vorbis-tools unzip libmysqlclient-devel libgcrypt-devel libgnutls-devel perl-macros fdupes automake perl-Sys-Mmap

%if 0%{?suse_version} > 1140
BuildRequires: systemd
%endif
%if %{with mp_package}
BuildRequires:  faac faad2 faad2-devel ffmpeg lame libffmpeg-devel libmp4v2-devel x264 libx264-devel xvid xvid-devel
%endif
%{perl_requires}
%{?systemd_requires}
Requires:       apache2 netpbm php5 apache2-mod_php5 php5-mysql php5-bz2 php5-gd php5-zlib php5-iconv php5-mcrypt php5-sockets mysql perl-Archive-Tar perl-Archive-Zip perl-DBI perl-DBD-mysql perl-Crypt-SSLeay perl-XML-Parser perl-libwww-perl perl-Date-Manip perl-MIME-Lite perl-MIME-tools php5-zip zip python-zm_database_init perl-PHP-Serialization perl-Sys-Mmap
PreReq:         permissions
%if %suse_version < 1120
Requires: perl-Module-Load
%endif
Requires(post): permissions
%if %{with mp_package}
Requires:       ffmpeg lame
%endif
Recommends:     perl-Device-SerialPort php5-gd perl-Net-SFTP-Foreign perl-Expect
%if %{with mp_package}
Conflicts:      ZoneMinder
%endif
License:        GPL
Group:          Productivity/Networking/Web/Servers
Summary:        Video camera security and surveillance
Version:        1.25.0
Release:        48.1
Packager:       Monex <monex@liquid-co.de>
URL:            http://www.zoneminder.com/
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Source0:        ZoneMinder-%{version}.tar.gz
Source1:        zm.init
Source2:        zm.service
Source3:        cambozola.jar
Source4:        README.cambozola.html
Source5:        LICENSE.cambozola
Source6:        zm.logrotate
Source7:        README.SuSE
Source8:        zm.apache
Source9:        permissions
Source10:       permissions.secure
Source11:       permissions.paranoid
Source12:       mootools-core-1.3.2-full-compat.js
Source13:       LICENSE.mootools
Source14:       zm_tempfiles.conf
Source15:       zm.sudoers
Patch1:         chown.patch
Patch2:         zm.conf.patch
Patch3:         zm_database_default_config.patch
Patch4:         fix_warnings.patch
Patch5:         configure_ac_ffmpeg.patch
Patch6:         limits-includes-fix.patch
Patch7:         zmpkg_db_init.patch
Patch8:         ignore_signal_on_config_write.patch
Patch9:         fix-ffmpeg-recognition-in-autoconf.patch
Patch10:        fix-ffmpeg-depreciated-function-calls_ffmpeg_0.11.patch
Patch11:        fix-gcc47.patch
Patch12:        unified-uptime-output.patch
Patch13:        use-enum-type-from-v4l.patch
Patch14:        systemd_zm_control.patch
Patch15:        generate_config_in_transaction.patch
Patch16:        zoneminder-1.25.0-textframe.patch
Patch17:        fix-ffmpeg-depreciated-function-calls_ffmpeg_1.0.1.patch

%description
ZoneMinder is a video camera security and surveillance system for linux

Authors:
--------
    Philip Coombes <philip.coombes@zoneminder.com>

%description -l de
ZoneMinder ist eine Video-Überwachungs-Suite für Linux

Authors:
--------
    Philip Coombes <philip.coombes@zoneminder.com>


%debug_package
%prep

%if %{with mp_package}
%setup -q -n ZoneMinder-%{version}
%else
%setup -q
%endif
cp -a %SOURCE4 .
cp -a %SOURCE5 .
cp -a %SOURCE7 .
cp -a %SOURCE10 .
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%if %{with mp_package}
%patch5 -p1
%patch9 -p1
%patch10 -p1
%endif
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%if 0%{?suse_version} > 1140
%patch14 -p1
%endif
%patch15 -p1
%patch17 -p1

aclocal
autoconf
automake

%build
export  ZM_DB_HOST=localhost
export  ZM_DB_NAME=zm
export  ZM_DB_USER=zm_admin
export  ZM_DB_PASS=pass
export  ZM_SSL_LIB=openssl
export  ZM_RUNDIR=/var/run/zm
export  ZM_TMPDIR=/tmp
export  ZM_LOGDIR=/var/log/zm
export  ZM_MYSQL_ENGINE=InnoDB

export CFLAGS=$RPM_OPT_FLAGS
export CXXFLAGS=$RPM_OPT_FLAGS

./configure \
  --with-mysql=/usr/include/mysql \
  --with-webdir=/srv/www/htdocs/zm \
  --with-cgidir=/srv/www/cgi-bin \
  --sysconfdir=/etc \
  --bindir=/usr/bin \
  --enable-mmap=yes \
%if %{with mp_package}
  --with-ffmpeg=/usr/include/ \
%else
  --without-ffmpeg \
%endif
%ifarch x86_64
  --with-libarch=lib64 \
%else
  --with-libarch=lib \
%endif
  --with-webuser=wwwrun \
  --with-webgroup=www \
%if %{with debug}
  --enable-crashtrace=yes \
  --enable-debug=yes \
%else
  --disable-crashtrace \
  --enable-debug=no \
%endif

# hack to install perl modules in vendor_perl instead of site_perl
pushd scripts/ZoneMinder
%{__perl} Makefile.PL INSTALLDIRS=vendor || return 1
popd

%{__make} %{?_smp_mflags}

%install
make DESTDIR=$RPM_BUILD_ROOT install
%perl_process_packlist
%perl_gen_filelist
%__install -m 700 -d %buildroot/usr/share/zm/db
%__install -m 600 db/*.sql %buildroot/usr/share/zm/db
for f in /etc/logrotate.d /etc/init.d /usr/sbin /etc/cron.hourly/ /var/log /etc/apache2/conf.d %{_sysconfdir}/permissions.d/ /var/run/zm %{_sysconfdir}/sudoers.d/
do
    %__install -d %buildroot/$f
done
%__install -m 754 %{S:1} %buildroot/etc/init.d/zm
%if 0%{?suse_version} >= 1210
  for f in %{_unitdir} /usr/lib/tmpfiles.d
  do
    %__install -d %buildroot/$f
  done

  %__install -m 644 %{S:2} %{buildroot}/%{_unitdir}
  %__install -m 644 %{S:14} %{buildroot}/usr/lib/tmpfiles.d
  %__install -m 440 %{S:15} %{buildroot}/etc/sudoers.d/zm
%endif

ln -s ../../etc/init.d/zm %buildroot/usr/sbin/rczm
%__install -m 644 %{S:3} %buildroot/srv/www/htdocs/zm/
%__install -m 775 -d %buildroot/var/log/zm
%__install -m 644 %{S:6} %buildroot/etc/logrotate.d/zm
%__install -m 644 %{S:8} %buildroot/etc/apache2/conf.d/zm.conf

%__install -m 644 %{S:9} %{buildroot}%{_sysconfdir}/permissions.d/%{name}
%__install -m 644 %{S:9} %{buildroot}%{_sysconfdir}/permissions.d/%{name}.easy

%__install -m 644 %{S:10} %{buildroot}%{_sysconfdir}/permissions.d/%{name}
%__install -m 644 %{S:11} %{buildroot}%{_sysconfdir}/permissions.d/%{name}

%__install -m 644 %{S:12} %buildroot/srv/www/htdocs/zm/mootools.js

echo %version > %buildroot/usr/share/zm/version


%fdupes -s $RPM_BUILD_ROOT/%_mandir
%fdupes $RPM_BUILD_ROOT

%if 0%{?suse_version} >= 1120
%verifyscript
%verify_permissions -e %{_bindir}/zmfix
if ! grep "#includedir /etc/sudoers.d" /etc/sudoers > /dev/null
then
  echo "#includedir /etc/sudoers.d" >> /etc/sudoers
fi
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files -f %{name}.files
%defattr(-,root,root)
%dir /usr/share/zm
%dir /usr/share/zm/db
/usr/share/zm/version
/usr/share/zm/db/*.sql
/etc/apache2/conf.d/*.conf
/srv/www/htdocs/zm/cambozola.jar
%dir /srv/www/htdocs/zm/ajax
/srv/www/htdocs/zm/ajax/*.php
%dir /srv/www/htdocs/zm/css
/srv/www/htdocs/zm/css/*
%dir /srv/www/htdocs/zm/graphics
/srv/www/htdocs/zm/graphics/*
%dir /srv/www/htdocs/zm/includes
/srv/www/htdocs/zm/includes/*.php
%dir /srv/www/htdocs/zm/js
/srv/www/htdocs/zm/js/*
%dir /srv/www/htdocs/zm/lang
/srv/www/htdocs/zm/lang/*.php
/srv/www/htdocs/zm/*.js
/srv/www/htdocs/zm/*.php
%dir /srv/www/htdocs/zm/skins
%dir /srv/www/htdocs/zm/skins/classic
%dir /srv/www/htdocs/zm/skins/classic/css
%dir /srv/www/htdocs/zm/skins/classic/graphics
%dir /srv/www/htdocs/zm/skins/classic/includes
%dir /srv/www/htdocs/zm/skins/classic/js
%dir /srv/www/htdocs/zm/skins/classic/views
%dir /srv/www/htdocs/zm/skins/classic/views/css
%dir /srv/www/htdocs/zm/skins/classic/views/js
%dir /srv/www/htdocs/zm/skins/mobile
%if 0%{?suse_version} < 1220
%dir /srv/www/htdocs/zm/skins/classic/ajax
%dir /srv/www/htdocs/zm/skins/classic/lang
%dir /srv/www/htdocs/zm/skins/mobile/ajax
%dir /srv/www/htdocs/zm/skins/mobile/lang
%dir /srv/www/htdocs/zm/skins/mobile/graphics
%endif
%dir /srv/www/htdocs/zm/skins/mobile/css
%dir /srv/www/htdocs/zm/skins/mobile/includes
%dir /srv/www/htdocs/zm/skins/mobile/views
%dir /srv/www/htdocs/zm/skins/mobile/views/css
%dir /srv/www/htdocs/zm/skins/xml/
%dir /srv/www/htdocs/zm/skins/xml/includes
%dir /srv/www/htdocs/zm/skins/xml/views
/srv/www/htdocs/zm/skins/classic/*.php
/srv/www/htdocs/zm/skins/classic/includes/*.php
/srv/www/htdocs/zm/skins/classic/views/*.php
/srv/www/htdocs/zm/skins/classic/views/css/*
/srv/www/htdocs/zm/skins/classic/views/js/*
/srv/www/htdocs/zm/skins/classic/views/Makefile.am
/srv/www/htdocs/zm/skins/classic/js/*
/srv/www/htdocs/zm/skins/classic/css/*
/srv/www/htdocs/zm/skins/classic/graphics/*
/srv/www/htdocs/zm/skins/mobile/*.php
/srv/www/htdocs/zm/skins/mobile/includes/*.php
/srv/www/htdocs/zm/skins/mobile/views/*.php
/srv/www/htdocs/zm/skins/mobile/views/css/*
/srv/www/htdocs/zm/skins/mobile/css/*
/srv/www/htdocs/zm/skins/xml/*.php
/srv/www/htdocs/zm/skins/xml/includes/*.php
/srv/www/htdocs/zm/skins/xml/views/*
/srv/www/htdocs/zm/views/*
%dir /srv/www/htdocs/zm/tools/
/srv/www/htdocs/zm/tools/*
/srv/www/cgi-bin/nph-zms
/srv/www/cgi-bin/zms
%dir /srv/www/htdocs/zm
%if 0%{?suse_version} >= 1210
  %{_unitdir}/*
  /usr/lib/tmpfiles.d/*
  /etc/sudoers.d/zm
%endif

%defattr(-,wwwrun,www)
%dir /srv/www/htdocs/zm/events
%dir /srv/www/htdocs/zm/images
%dir /srv/www/htdocs/zm/sounds
%dir /srv/www/htdocs/zm/temp
%dir /srv/www/htdocs/zm/views
%ghost /var/run/zm

%defattr(-,root,root)
%verify(not mode) %attr(0755,root,root) /usr/bin/zmfix
%_sysconfdir/permissions.d/*
%config(noreplace) /etc/init.d/zm
%_sbindir/rczm
/etc/logrotate.d/zm
%doc AUTHORS COPYING ChangeLog INSTALL NEWS README* LICENSE*
%defattr(640,root,www)
%config(noreplace) /etc/zm.conf
%defattr(-,root,www)
%dir /var/log/zm

%post
/sbin/ldconfig
touch /usr/share/zm/lock

%if 0%{?set_permissions:1} > 0
    %set_permissions /usr/bin/zmfix
%else
    %run_permissions
%endif

%if 0%{?suse_version} >= 1210
  %service_add_post zm.service
  systemd-tmpfiles --create
%endif

%pre
%if 0%{?suse_version} >= 1210
  %service_add_pre zm.service
%endif

%preun
%stop_on_removal zm
if [ $1 -eq 0 ]; then
    if test -f /usr/share/zm/lock ; then
        rm -f /usr/share/zm/lock
    fi
fi

%if 0%{?suse_version} >= 1210
  %service_del_preun zm.service
%endif

%postun
%insserv_cleanup
/sbin/ldconfig

%if 0%{?suse_version} >= 1210
  %service_del_postun zm.service
%endif

%if %{with mp_package}
%else
%endif
%changelog
* Sat Aug 10 2013 monex@liquid-co.de
- fix ffmpeg deprecated functions
* Mon Apr 29 2013 monex@liquid-co.de
- added patch from https://bugzilla.redhat.com/show_bug.cgi?id=903063
* Sat Apr 20 2013 monex@liquid-co.de
- delete/insert config within transaction to prevent
  invalid configuration reads by other processes.
- use systemd to start/stop/restart ZoneMinder via webfrontent.
  Using zmpkg.pl from webfrontend confused systemd which then
  showed a wrong state.
  This behaviour is optional so new configuration option under
  in system category was introduced.
* Thu Apr 11 2013 monex@liquid-co.de
- updated systemd unit file to use ZoneMinder PIDFile
  Type is forking now instead of simple
* Fri Mar 29 2013 monex@liquid-co.de
- compile zoneminder with mmap enables
* Tue Mar 12 2013 monex@liquid-co.de
- applied patch for shared memory debug purpose
* Tue Mar 12 2013 monex@liquid-co.de
- use cast instead
* Tue Mar 12 2013 monex@liquid-co.de
- fix compile for 12.3 by using v4l enum type
  found another one
* Tue Mar 12 2013 monex@liquid-co.de
- fix compile for 12.3 by using v4l enum type
* Tue Mar 12 2013 monex@liquid-co.de
- added unified uptime patch to fix uptime output
  in webfrontend
* Sat Mar  9 2013 monex@liquid-co.de
- changed dependency from x264-devel to libx264-devel
* Tue Oct 16 2012 monex@liquid-co.de
- rebuild package due to changed ffmpeg libs
* Tue Sep 11 2012 monex@liquid-co.de
- fix file list
* Tue Sep 11 2012 monex@liquid-co.de
- added use of RPM_OPT_FLAGS
* Tue Sep 11 2012 monex@liquid-co.de
- added fix compile patch for gcc-4.7
* Sun Sep  9 2012 monex@liquid-co.de
- removed unneded BuildRequires
* Sat Aug 11 2012 monex@liquid-co.de
- remove last patch as it is a php configuration issue
* Wed Aug  8 2012 monex@liquid-co.de
- first try to fix hash auth, looking out for a better solution soon
* Sat Jul 28 2012 monex@liquid-co.de
- fix compile with newer ffmpeg versions
* Wed Mar 21 2012 monex@liquid-co.de
- added startup message again
* Wed Mar 21 2012 monex@liquid-co.de
- fixed name in requires: perl-PHP-Serialization
* Tue Mar 20 2012 monex@liquid-co.de
- removed obsolete entries in init file
* Tue Mar 20 2012 monex@liquid-co.de
- added perl-php-serialization to requires so that triggers are working
* Sun Jan  1 2012 monex@liquid-co.de
- corrected last patch
* Sun Jan  1 2012 monex@liquid-co.de
- ignore signals in ConfigAdmin module to prevent Config table corruption
* Sat Dec 31 2011 monex@liquid-co.de
- fix unit file
- don't restart on update beause on systemd it will be double executed which will break
  the configuration table in database
* Fri Dec 30 2011 monex@liquid-co.de
- added restart section to unit file
* Fri Dec 30 2011 monex@liquid-co.de
- disable restart on update as it will break the Config table ind database (why?)
* Fri Dec 30 2011 monex@liquid-co.de
- added automake to build requires
* Fri Dec 30 2011 monex@liquid-co.de
- clean up old changes section
* Fri Dec 30 2011 monex@liquid-co.de
- added missing file
- fix in changelog file
